program CollectiveOperation_Form_Test

  use VariableManagement
  use Display
  use MessagePassingBasics
  use REDUCTION_Singleton
  use CollectiveOperationInteger_Form
  use CollectiveOperationBigInteger_Form
  use CollectiveOperationReal_Form
  use CollectiveOperationComplex_Form

  implicit none

  integer ( KDI ) :: &
    iV, &
    nOutgoing
  complex ( KDC ) :: &
    ComplexValue
  type ( CommunicatorForm ), allocatable :: &
    C
  type ( CollectiveOperationIntegerForm ), allocatable :: &
    CO_I
  type ( CollectiveOperationBigIntegerForm ), allocatable :: &
    CO_BI
  type ( CollectiveOperationRealForm ), allocatable :: &
    CO_R
  type ( CollectiveOperationComplexForm ), allocatable :: &
    CO_C

  allocate ( C )
  call C % Initialize ( )
  call CONSOLE % Initialize ( C % Rank )
  call CONSOLE % SetDisplayRank ( 0 )
  
!  nOutgoing = 120
  nOutgoing = 8

  !-- Broadcast Integer

  call Show ( 'Broadcast Integer' )

  allocate ( CO_I ) 
  call CO_I % Initialize &
         ( C, nOutgoing = [ nOutgoing ], nIncoming = [ nOutgoing ], &
           RootOption = C % Size - 1 ) 
           
  if ( C % Rank == CO_I % Root ) &
    CO_I % Outgoing % Value &
      = ( C % Rank + 1 ) * [ ( iV, iV = 1, nOutgoing ) ]
             
  call CO_I % Broadcast ( )
  
  call Show ( CO_I % Incoming % Value, 'IncomingValue_1D Integer' )

  deallocate ( CO_I ) 
    
  !-- AllGather Integer
  
  call Show ( 'AllGather Integer' )

  allocate ( CO_I ) 
  call CO_I % Initialize &
         ( C, nOutgoing = [ nOutgoing ], nIncoming = C % Size * [ nOutgoing ] ) 
           
  CO_I % Outgoing % Value &
    = ( C % Rank + 1 ) * [ ( iV, iV = 1, nOutgoing ) ]
             
  call CO_I % Gather ( )
  
  call Show ( CO_I % Incoming % Value, 'IncomingValue_1D Integer' )

  deallocate ( CO_I ) 
  
  !-- AllGather Integer_KBI
  
  call Show ( 'AllGather Integer_KBI' )

  allocate ( CO_BI ) 
  call CO_BI % Initialize &
         ( C, nOutgoing = [ nOutgoing ], nIncoming = C % Size * [ nOutgoing ] ) 
           
  CO_BI % Outgoing % Value &
    = int ( C % Rank + 1, KBI ) * [ ( iV, iV = 1, nOutgoing ) ]
             
  call CO_BI % Gather ( )
  
  call Show ( CO_BI % Incoming % Value, 'IncomingValue_1D Integer_KBI' )

  deallocate ( CO_BI ) 
  
  !-- AllGather Real
  
  call Show ( 'AllGather Real' )

  allocate ( CO_R ) 
  call CO_R % Initialize &
         ( C, nOutgoing = [ nOutgoing ], nIncoming = C % Size * [ nOutgoing ] ) 
           
  CO_R % Outgoing % Value &
    = ( acos ( - 1.0_KDR ) * ( C % Rank + 1 ) * [ ( iV, iV = 1, nOutgoing ) ] )
             
  call CO_R % Gather ( )

  call Show ( CO_R % Incoming % Value, 'IncomingValue_1D Real' )

  deallocate ( CO_R ) 
  
  !-- Gather Real
  
  call Show ( 'Gather Real' )

  allocate ( CO_R ) 
  call CO_R % Initialize &
         ( C, nOutgoing = [ nOutgoing ], nIncoming = C % Size * [ nOutgoing ], &
           RootOption = CONSOLE % DisplayRank ) 
           
  CO_R % Outgoing % Value &
    = ( acos ( - 1.0_KDR ) * ( C % Rank + 1 ) * [ ( iV, iV = 1, nOutgoing ) ] )
             
  call CO_R % Gather ( )

  call Show ( CO_R % Incoming % Value, 'IncomingValue_1D Real' )

  deallocate ( CO_R ) 
  
  !-- AllToAll Complex
  
  call Show ( 'AllToAll Complex' )

  allocate ( CO_C ) 
  call CO_C % Initialize & 
         ( C, nOutgoing = [ nOutgoing ] * C % Size, &
           nIncoming = [ nOutgoing ] * C % Size )

  ComplexValue &
    = cmplx ( ( C % Rank + 1 ) * 1.0_KDR, &
              ( C % Rank + 1 ) * acos ( - 1.0_KDR ) )
  CO_C % Outgoing % Value &
    = spread ( ComplexValue, dim = 1, ncopies = nOutgoing * C % Size )
  
  call CO_C % AllToAll ( )
  
  call Show ( CO_C % Incoming % Value, 'IncomingValue_1D Complex' )

  deallocate ( CO_C ) 
    
  !-- Reduction

  call Show ( 'AllReduce Real' )

  allocate ( CO_R ) 
  call CO_R % Initialize & 
         ( C, nOutgoing = [ nOutgoing ], nIncoming = [ nOutgoing ] )

  CO_R % Outgoing % Value &
    = ( C % Rank + 1 ) * [ ( real ( iV, KDR ), iV = 1, nOutgoing ) ]

  call CO_R % Reduce ( REDUCTION % SUM )
 
  call Show ( CO_R % Incoming % Value, 'IncomingValue_1D Real' )

  deallocate ( CO_R )
  
  deallocate ( C )

end program CollectiveOperation_Form_Test
